package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
public class NodeSubsetDef {
  protected NodeSubsetName nodesubsetname;
  public NodeSubsetName get_nodesubsetname() { return nodesubsetname; }
  public void set_nodesubsetname(NodeSubsetName new_nodesubsetname) { nodesubsetname = new_nodesubsetname; }
  protected NodeSubsetExpression nodesubsetexpression;
  public NodeSubsetExpression get_nodesubsetexpression() { return nodesubsetexpression; }
  public void set_nodesubsetexpression(NodeSubsetExpression new_nodesubsetexpression) { nodesubsetexpression = new_nodesubsetexpression; }
  public NodeSubsetDef() { super(); }
  public NodeSubsetDef(NodeSubsetName nodesubsetname, NodeSubsetExpression nodesubsetexpression) {
    super();
    set_nodesubsetname(nodesubsetname);
    set_nodesubsetexpression(nodesubsetexpression);
  }
  public static NodeSubsetDef parse(java.io.Reader in) throws ParseException { return new Parser(in)._NodeSubsetDef(); }
  public static NodeSubsetDef parse(java.io.InputStream in) throws ParseException { return new Parser(in)._NodeSubsetDef(); }
  public static NodeSubsetDef parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_nodesubsetname(this, nodesubsetname);
    nodesubsetname.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_nodesubsetname(this, nodesubsetname);
    ((UniversalVisitor) _v_).before_nodesubsetexpression(this, nodesubsetexpression);
    nodesubsetexpression.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_nodesubsetexpression(this, nodesubsetexpression);
    universal_trv0_aft(_v_);
  }

}
